#pragma once

#include "IGameBuilder.h"

class CommonBuilder: public IGameBuilder {
public:
    virtual void create_rooms() = 0;
    virtual void set_rooms_sides() = 0;
    void create_context(float dynamic_objects_ratio) override;
    void create_state(IStateManager& state_manager,
        sf::VideoMode video_mode, const std::string& window_title) override;
    void set_all_to_state() override;
    std::unique_ptr<GameState> get_game() override;
public:
    CommonBuilder(float width, float height, float room_size);
    virtual ~CommonBuilder() = default;
public:
    std::vector<std::vector<std::unique_ptr<Room>>> m_rooms;
protected:
    float m_width;
    float m_height;
    float m_room_size;
private:
    GameContext m_context;
    std::unique_ptr<GameState> m_game_state;
};
