#pragma once

#include "IEntity.h"
#include <Visit/IVisitor.h>

class Pacman: public IEntity, public IVisitor {
public:
    void prepare_for_drawing() override;
    void draw_into(sf::RenderWindow& window) const override;
    void move(Room::Direction direction);
    std::unique_ptr<IGameEvent> visit(Food* ptr_food) override;
    std::unique_ptr<IGameEvent> visit(Enemy* ptr_enemy) override;
public:
    Pacman();
private:
    sf::CircleShape m_circle;
};